<?php
namespace Drupal\qubit;

use DateTimeZone;
use Drupal\qubit\UniversalVariable\QubitPage;
use Drupal\qubit\UniversalVariable\QubitProduct;
use Drupal\qubit\UniversalVariable\QubitUser;
use Drupal\qubit\UniversalVariable\Product\QubitAccommodation;
use Drupal\qubit\UniversalVariable\Product\QubitJourney;

/**
 * Generated by PHPUnit_SkeletonGenerator 1.2.1 on 2013-10-29 at 16:16:41.
 */
class QubitUniversalVariableTest extends \PHPUnit_Framework_TestCase {
  /**
   * @var QubitUniversalVariable
   */
  protected $universalVariable;

  /**
   * Sets up the fixture, for example, opens a network connection.
   * This method is called before a test is executed.
   */
  protected function setUp() {
    $this->universalVariable = new QubitUniversalVariable;
  }

  /**
   * Tears down the fixture, for example, closes a network connection.
   * This method is called after a test is executed.
   */
  protected function tearDown() {
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getVersion
   */
  public function testGetVersion() {
    $variable = $this->universalVariable;

    $valid_version_format = '%d.%d.%d';

    $this->assertStringMatchesFormat($valid_version_format, $variable->getVersion(), "The version number is not in a valid format");
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::__toString
   */
  public function test__toString() {
    $object = $this->universalVariable;

    $expected = '{ }';

    $actual = strval($object);

    $this->assertJsonStringEqualsJsonString($expected, $actual);
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getIterator
   */
  public function testGetIterator() {
    $var = $this->universalVariable;

    $this->assertInstanceOf('ArrayIterator', $var->getIterator());
    $this->assertInstanceOf('Traversable', $var->getIterator());
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getIterator
   */
  public function testIterateAllProperties() {
    $var = $this->universalVariable;

    $var->setPage(new \Drupal\qubit\UniversalVariable\QubitPage);

    $count = 0;
    foreach ($var as $property_name => $property_value) {
      $count++;
    }

    $this->assertEquals(8, $count, "The foreach Iterator should have iterated all 8 properties");
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getIterator
   */
  public function testIteratorShowsSetPropertyValue() {
    $var = $this->universalVariable;

    $page = new \Drupal\qubit\UniversalVariable\QubitPage;
    $var->setPage($page);

    $page_property_value = NULL;
    foreach ($var as $property_name => $property_value) {
      if ($property_name == 'page') {
        $page_property_value = $property_value;
      }
    }

    $this->assertEquals(
      $page, $page_property_value,
      "The property of 'page' should be of type 'Page' when iterated over"
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::__unset()
   */
  public function testUnsetPage() {
    $variable = $this->universalVariable;
    $page = new QubitPage;

    $variable->setPage($page);

    try {
      unset($variable->{'page'});
    }
    catch (\Exception $e) {
      $this->fail("An exception should not be thrown");
    }

    $this->assertEmpty($variable->getPage(), "Page should be empty if unset");
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::setPage
   */
  public function testSetPageWithValidData() {
    $variable = $this->universalVariable;
    $page = new QubitPage;

    try {
      $variable->setPage($page);
    }
    catch (\Exception $e) {
      $this->fail("An exception should not be thrown");
    }

    $this->assertNotEmpty($variable->getPage());
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getPage
   */
  public function testGetPage() {
    $variable = $this->universalVariable;
    $page = new QubitPage;

    try {
      $variable->setPage($page);
    }
    catch (\Exception $e) { }

    $this->assertEquals($page, $variable->getPage());
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::setProduct
   */
  public function testSetProduct() {
    $variable = $this->universalVariable;
    $value = new QubitProduct;

    try {
      $variable->setProduct($value);
    }
    catch (\Exception $e) {
      $this->fail("An exception should not be thrown");
    }

    $this->assertNotEmpty($variable->getProduct());
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getProduct
   */
  public function testGetProduct() {
    $variable = $this->universalVariable;
    $value = new QubitProduct;

    try {
      $variable->setProduct($value);
    }
    catch (\Exception $e) { }

    $this->assertEquals($value, $variable->getProduct());
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::setUser
   */
  public function testSetUser() {
    $variable = $this->universalVariable;
    $value = new QubitUser;

    try {
      $variable->setUser($value);
    }
    catch (\Exception $e) {
      $this->fail("An exception should not be thrown");
    }

    $this->assertNotEmpty($variable->getUser());
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getUser
   */
  public function testGetUserWhenSet() {
    $variable = $this->universalVariable;
    $value = new QubitUser;

    try {
      $variable->setUser($value);
    }
    catch (\Exception $e) {
    }

    $this->assertEquals(
      $value, $variable->getUser(),
      "User returned by getUser should be the same one given to setUser"
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getUser
   */
  public function testGetUserWhenEmpty() {
    $variable = $this->universalVariable;

    $this->assertEmpty($variable->getUser());

    $actual = $variable->getUser();
    $this->assertFalse(isset($actual), "Method isset() should evaluate false for getUser when a User has not been set");
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getEvents
   * @todo   Implement testGetEvents().
   */
  public function testGetEvents() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::setEvents
   * @todo   Implement testSetEvents().
   */
  public function testSetEvents() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::unsetEvents
   * @todo   Implement testUnsetEvents().
   */
  public function testUnsetEvents() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::setBasket
   * @todo   Implement testSetBasket().
   */
  public function testSetBasket() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getBasket
   * @todo   Implement testGetBasket().
   */
  public function testGetBasket() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::setTransaction
   * @todo   Implement testSetTransaction().
   */
  public function testSetTransaction() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getTransaction
   * @todo   Implement testGetTransaction().
   */
  public function testGetTransaction() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::setListing
   * @todo   Implement testSetListing().
   */
  public function testSetListing() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getListing
   * @todo   Implement testGetListing().
   */
  public function testGetListing() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::setRecommendation
   * @todo   Implement testSetRecommendation().
   */
  public function testSetRecommendation() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::getRecommendation
   * @todo   Implement testGetRecommendation().
   */
  public function testGetRecommendation() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::jsonSerialize
   */
  public function testJsonSerializeWhenEmpty() {
    $var = $this->universalVariable;

    $is_serialized_object = is_object($var->jsonSerialize());
    $this->assertTrue($is_serialized_object, "Should always return an object when serialized");

    $actual = json_encode($var->jsonSerialize());
    $expected = '{ }';
    $this->assertJsonStringEqualsJsonString($expected, $actual, "Should encode to an empty JSON object when empty");
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::jsonSerialize
   */
  public function testJsonSerializeWhenNotEmpty() {
    $var = $this->universalVariable;

    $page = new QubitPage;
    $page->setEnvironment("testing");

    $var->setPage($page);

    $is_serialized_object = is_object($var->jsonSerialize());
    $this->assertTrue($is_serialized_object, "Should always return an object when serialized");

    $actual = json_encode($var->jsonSerialize());
    $this->assertJson($actual, "Should encode as json if properties are set");
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::jsonSerialize
   */
  public function testjsonSerialize_json_encode_NestedObjectValues() {
    $variable = $this->universalVariable;
    $product = new QubitProduct;
    $page = new QubitPage;

    $product
      ->setId("123")
      ->setName("test");

    $page->setEnvironment("testing");

    $variable
      ->setPage($page)
      ->setProduct($product);

    $serialized = $variable->jsonSerialize();
    $actual = json_encode($serialized);

    $expected = '{ "product" : { "id" : "123", "name" : "test" }, "page" : { "environment" : "testing" } }';

    $this->assertJsonStringEqualsJsonString($expected, $actual);
  }

  /**
   * @covers Drupal\qubit\QubitUniversalVariable::jsonSerialize
   */
  public function testjsonSerialize_json_encode_NestedArrayDateTimeValues() {
    $variable = $this->universalVariable;

    $timezone = new DateTimeZone('UTC');

    $time = new \DateTime;
    $time->setTimezone($timezone);
    $time->setDate(2013, 1, 30);
    $time->setTime(2, 30, 15);

    $journey_one = new QubitJourney;
    $journey_one->setCode("A1")
      ->setName("test journey 1")
      ->setTime($time);

    $journey_two = new QubitJourney;
    $journey_two->setCode("B2")
      ->setName("test journey 2");

    $journeys = array($journey_one, $journey_two);

    $product = new QubitProduct;
    $product
      ->setId("123")
      ->setName("test product name")
      ->setJourneys($journeys);

    $variable
      ->setProduct($product);

    $serialized = $variable->jsonSerialize();

    $actual = json_encode($serialized);
    $expected = '{ "product" : { "id" : "123", "name" : "test product name", "journeys" : [ { "code" : "A1", "name" : "test journey 1", "time" : "2013-01-30T02:30:15+0000" }, { "code" : "B2", "name" : "test journey 2" } ] } }';

    $this->assertJsonStringEqualsJsonString($expected, $actual);
  }

}
