<?php
namespace Drupal\qubit\UniversalVariable;

/**
 * Generated by PHPUnit_SkeletonGenerator 1.2.1 on 2013-11-04 at 16:08:23.
 */
class QubitUserTest extends \PHPUnit_Framework_TestCase {
  /**
   * @var QubitUser
   */
  protected $object;

  /**
   * Sets up the fixture, for example, opens a network connection.
   * This method is called before a test is executed.
   */
  protected function setUp() {
    $this->object = new QubitUser;
  }

  /**
   * Tears down the fixture, for example, closes a network connection.
   * This method is called after a test is executed.
   */
  protected function tearDown() {
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::__unset
   */
  public function test__unset() {
    $user = $this->object;

    $user->setUserId("1234");
    unset($user->{'user_id'});

    $this->assertEmpty($user->getUserId(), "Should be empty after being unset");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setRealName
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getRealName
   */
  public function testSetRealName() {
    $user = $this->object;

    $name = "Test Testerson";
    $user->setRealName($name);

    $this->assertEquals($name, $user->getRealName());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getRealName
   */
  public function testGetRealNameWhenNotSet() {
    $user = $this->object;

    $this->assertEmpty($user->getRealName(), "Should be empty when not set");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::__unset
   */
  public function test__unset_RealName() {
    $user = $this->object;

    $user->setRealName("Test");
    unset($user->{'real_name'});

    $this->assertEmpty($user->getRealName(), "Should be empty when unset");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::__unset
   */
  public function test__unset_Name() {
    $user = $this->object;

    $user->setRealName("Test");
    unset($user->{'name'});

    $this->assertEmpty($user->getRealName(), "Should be empty when unset");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setLoginName
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getLoginName
   */
  public function testSetLoginName() {
    $user = $this->object;

    $login = "Test.Login";
    $user->setLoginName($login);

    $this->assertEquals($login, $user->getLoginName());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getLoginName
   */
  public function testGetLoginNameWhenNotSet() {
    $user = $this->object;

    $this->assertEmpty($user->getLoginName(), "Should be empty when not set");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::__unset
   */
  public function test__unset_LoginName() {
    $user = $this->object;

    $user->setLoginName("Test");
    unset($user->{'login_name'});

    $this->assertEmpty($user->getLoginName(), "Should be empty when unset");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::__unset
   */
  public function test__unset_Login() {
    $user = $this->object;

    $user->setLoginName("Test");
    unset($user->{'username'});

    $this->assertEmpty($user->getLoginName(), "Should be empty when unset");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setUserId
   * @todo   Implement testSetUserId().
   */
  public function testSetUserId() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getUserId
   * @todo   Implement testGetUserId().
   */
  public function testGetUserId() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setEmail
   * @todo   Implement testSetEmail().
   */
  public function testSetEmail() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getEmail
   * @todo   Implement testGetEmail().
   */
  public function testGetEmail() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setLanguage
   * @todo   Implement testSetLanguage().
   */
  public function testSetLanguage() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getLanguage
   * @todo   Implement testGetLanguage().
   */
  public function testGetLanguage() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setHasReturned
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasReturned
   */
  public function testSetHasReturned() {
    $user = $this->object;

    $user->setHasReturned(TRUE);

    $this->assertTrue($user->getHasReturned());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setHasReturned
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasReturned
   */
  public function testSetHasReturnedFalse() {
    $user = $this->object;

    $user->setHasReturned(FALSE);

    $this->assertFalse($user->getHasReturned());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setHasReturned
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasReturned
   */
  public function testSetHasReturnedToOne() {
    $user = $this->object;

    $user->setHasReturned(1);

    $this->assertTrue($user->getHasReturned());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setHasReturned
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasReturned
   */
  public function testSetHasReturnedToZero() {
    $user = $this->object;

    $user->setHasReturned(0);

    $this->assertFalse($user->getHasReturned());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasReturned
   */
  public function testGetHasReturnedWhenNotSet() {
    $user = $this->object;

    $this->assertEmpty($user->getHasReturned(), "Should be empty when not set");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::__unset
   */
  public function test__unset_Returning() {
    $user = $this->object;

    $user->setHasReturned(TRUE);
    unset($user->{'returning'});

    $this->assertEmpty($user->getHasReturned(), "Should be empty when unset");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::__unset
   */
  public function test__unset_HasReturned() {
    $user = $this->object;

    $user->setHasReturned(TRUE);
    unset($user->has_returned);

    $this->assertEmpty($user->getHasReturned(), "Should be empty when unset");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setHasTransacted
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasTransacted
   */
  public function testSetHasTransacted() {
    $user = $this->object;

    $user->setHasTransacted(TRUE);

    $this->assertTrue($user->getHasTransacted());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setHasTransacted
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasTransacted
   */
  public function testSetHasTransactedFalse() {
    $user = $this->object;

    $user->setHasTransacted(FALSE);

    $this->assertFalse($user->getHasTransacted());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setHasTransacted
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasTransacted
   */
  public function testSetHasTransactedOne() {
    $user = $this->object;

    $user->setHasTransacted(1);

    $this->assertTrue($user->getHasTransacted());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setHasTransacted
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasTransacted
   */
  public function testSetHasTransactedZero() {
    $user = $this->object;

    $user->setHasTransacted(0);

    $this->assertFalse($user->getHasTransacted());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getHasTransacted
   */
  public function testGetHasTransactedWhenNotSet() {
    $user = $this->object;

    $this->assertEmpty($user->getHasTransacted(), "Should be empty when not set");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::__unset
   */
  public function test__unset_HasTransacted() {
    $user = $this->object;

    $user->setHasTransacted(TRUE);
    unset($user->{'has_transacted'});

    $this->assertEmpty($user->getHasTransacted(), "Should be empty when unset");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setTypes
   * @todo   Implement testSetTypes().
   */
  public function testSetTypes() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getTypes
   * @todo   Implement testGetTypes().
   */
  public function testGetTypes() {
    // Remove the following lines when you implement this test.
    $this->markTestIncomplete(
      'This test has not been implemented yet.'
    );
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setFacebookId
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getFacebookId
   */
  public function testSetFacebookId() {
    $user = $this->object;

    try {
      $user->setFacebookId("012345");
    }
    catch (\Exception $e) {
    }

    $this->assertEquals("012345", $user->getFacebookId(), "Should match the value set.");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setFacebookId
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getFacebookId
   */
  public function testSetFacebookIdInteger() {
    $user = $this->object;

    try {
      $user->setFacebookId(789);
    }
    catch (\Exception $e) {
    }

    $this->assertEquals("789", $user->getFacebookId(), "Should match the value set.");
    $this->assertTrue(is_string($user->getFacebookId()), "Should be of type string.");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setFacebookId
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getFacebookId
   */
  public function testSetFacebookIdNonNumeric() {
    $user = $this->object;

    try {
      $user->setFacebookId("abc");
      $this->fail("Exception expected when non-numeric value is set.");
    }
    catch (\Exception $e) { }

    $this->assertEmpty($user->getFacebookId());
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getFacebookId
   */
  public function testGetFacebookIdWhenNotSet() {
    $user = $this->object;

    $this->assertEmpty($user->getFacebookId(), "Should be empty when not set.");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::setTwitterId
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getTwitterId
   */
  public function testSetTwitterId() {
    $user = $this->object;

    $user->setTwitterId('@foobartweet');

    $this->assertEquals('@foobartweet', $user->getTwitterId(), "Should equal the value set.");
  }

  /**
   * @covers Drupal\qubit\UniversalVariable\QubitUser::getTwitterId
   */
  public function testGetTwitterIdWhenNotSet() {
    $user = $this->object;

    $this->assertEmpty($user->getTwitterId(), "Should be empty when not set.");
  }
}
